#include "stdafx.h"
#include <stdio.h>
#include <stdlib.h>
#include <conio.h>
#include <time.h>

void writebyte (unsigned char wert)
{
	while (!(_inp(0x379) & 128));
	_outp (0x378, wert);
	_outp (0x37A, 2);
	_outp (0x378, wert);
	_outp (0x37A, 3);
	_outp (0x37A, 2);
}

void writecom (unsigned char wert)
{
	while (!(_inp(0x379) & 128));
	_outp (0x378, wert);
	_outp (0x37A, 0);
	_outp (0x378, wert);
	_outp (0x37A, 1);
	_outp (0x37A, 0);
}

void setpwm (unsigned char wert)
{
	writecom (2);
	writebyte (wert);
}

void setcursor (unsigned int x, unsigned int y)
{
	writecom(1);
	writebyte(y%240);
	writebyte((y/240)*128+(x/8));
}

void writetext (char *text)
{
	while (*text)
	{	writecom(192);
		writebyte(*text++);
	}
}

void loadbmp(char *file, unsigned int xp, unsigned int yp)
{	unsigned int x, y, i, xsize,ysize,farbe,farben,daten;
	char buffer[32];
	FILE *fp;

	fp=fopen (file,"rb");

	fread(buffer,1,2,fp);
	if ((buffer[0]!='B')&&(buffer[1]!='M'))		//Windows BMP Datei ?
	{	fclose(fp);
		printf ("Ungltige Datei !");
		while (!kbhit());
		return;
	}

	fread(buffer,1,16,fp);

	fread(&xsize,4,1,fp);	//Breite
	fread(&ysize,4,1,fp);	//Hhe

	fread(buffer,1,2,fp);
	fread(&farbe,2,1,fp);	//Farbe
	fread(buffer,1,4,fp);	//Compression

	if ((buffer[0]!=0)&&(buffer[1]!=0))
	{	fclose(fp);
		printf ("Unbekannte Kompression !");
		while (!kbhit());
		return;
	}

	fread(&daten,4,1,fp);	//Daten

	fread(buffer,1,8,fp);	//Auflsung
	
	fread(&farben,4,1,fp);	//Farben
	
	fread(buffer,1,4,fp);

	if (farben==0)
		farben=1<<farbe;

	if (farben!=2)		//Windows BMP Datei ?
	{	fclose(fp);
		printf ("Es werden nur 2 Farben SW BMPs untersttzt ! (BMP Datei hat %i Farben)",farben);
		while (!kbhit());
		return;
	}

	for (i=0; i<farben; i++)
		fread(buffer,1,4,fp);

	printf ("Breite : %i\n",xsize);
	printf ("Hhe   : %i\n",ysize);
	printf ("Farben : %i\n",farben);

	for (y=0; y<ysize; y++)
	{
		setcursor (xp,ysize-1-y+yp);
		for (x=0; x<(xsize/8); x++)
			writebyte (fgetc(fp));
		while (x&3)
		{	fread(buffer,1,1,fp);
			x++;
		}
	}
	fclose(fp);
while (!kbhit());
}

int main(int argc, char* argv[])
{	unsigned int x, y;

	setpwm(70);							//Kontrast einstellen

	setcursor (0,0);					//Adresspointer an Bildanfang setzen

	for (y=0; y<480; y++)				//Schachbrettmuster erzeugen
		for (x=0; x<640/8; x++)
		{if ((x+y/8)&1)
				writebyte (255);
			else
				writebyte (0);
		}

	setcursor (300,8);
	writetext ("Bitmap Test");

	if ((argc==1) || (argc>3)) 
	{	printf("Usage: lcdtest <Bild.BMP> [PWM Wert]\n");
	while (!kbhit());
		return 1;
	}
	if (argc==3)
	{	setpwm((char)atoi(argv[2]));	
		printf ("%i", atoi(argv[2]));
			while (!kbhit());
	}

	loadbmp (argv[1], 0,0);

	return 0;
}